FUNCTION FetchFile()  // Called by SETKEY( K_F10, {||FetchFile()} )

 // (C) 1994 Richard Eddy, S.R. Eddy & Associates & placed in the
 // public domain.

 // Function does the best it can with purely Clipper code
 // rather than use 3rd Party or C routines

 LOCAL        i := 0 ,;  // Incremental counter
           aDir := {},;  // Array for directory listing
          cDisk := "",;
       aDisplay := {},;  // Array for screen pick list
           nLen := 0 ,;
           cDir := STRTRAN( "\"+CURDIR()+"\", "\\", "\" ),; // Path to root
        nChoice := 0

 STATIC nDrives := 0     // Number of drives (floppy & hard disk)

 // Count the number of hard disks the first time the function is called
 IF nDrives == 0
  i := 67      // ASC( "C" )
  nDrives := 2 // A & B assumed - user must use common sense
  DO WHILE .T.
   aDir := DIRECTORY( CHR(i++) + ":\*.*" )
   IF !EMPTY( aDir )
    // Found a drive - increment number of drives
    nDrives++
   ELSE
    // Nothing found here - exit
    EXIT
   ENDIF
  ENDDO
 ENDIF

 // Find out which hard disk is presently being accessing
 FOR i := 3 TO nDrives
  cDisk := CHR( 64 + i ) + ":"
  IF CURDIR( cDisk ) == CURDIR()
   // Found the hard disk
   EXIT
  ENDIF
 NEXT

 DO WHILE .T.
  // Get directory listing, including sub-directory names
  aDir := DIRECTORY( cDisk + cDir + "*.*", "D" )
  // Put sub-directories at the top of the pick list, after "." & ".."
  aDir := ASORT( aDir,;
        IF( LEN( cDisk + cDir ) == 3, 1, 3 ),,; // Start @ 3 if a s/dir
   {|x,y|(IF(x[5]=="D","0","1")+x[1])<(IF(y[5]=="D","0","1")+y[1])} )

  // Dimension the display array rather than fragment memory with AADD()
  nLen := LEN( aDir )
  aDisplay := ARRAY( nLen )
  AEVAL( aDir, {|aFile,x|aDisplay[x]:=;
                                 PADR(aFile[F_NAME],12)+;
         IF( aFile[F_ATTR] =="D",PADR("<DIR>",10),;
                            TRANSFORM(aFile[F_SIZE],"##,###,###"))+" "+;
                                 DTOC(aFile[F_DATE])+" "+;
                                      aFile[F_TIME]} )
  IF LEN( cDisk + cDir ) == 3
   // Must be a root directory - put drives at top as additional options
   ASIZE( aDir, LEN( aDir ) + ( nDrives - 1 ) )
   ASIZE( aDisplay, LEN( aDisplay ) + ( nDrives - 1 ) )
   FOR i := nDrives TO 1 STEP -1
    IF CHR( 64+i ) + ":" # cDisk
     AINS( aDir, 1 )          // Keep size/elements of aDir in phase with
     AINS( aDisplay, 1 )      //                       aDisplay
     aDisplay[1] := CHR( 64+i ) + ":"
    ENDIF
   NEXT
  ENDIF

  // Use your own preferred pick list display function here
//  nChoice := BestChoice( aDisplay, 39, "C", 3, "T", "W+/G,N/W*",;
//                         "Directory of " + cDisk + cDir,,,;
//                         "Highlight file to read into Sub-Topic" )
  DO CASE
   CASE nChoice == 0
    // Nothing selected - exit & return
    EXIT
   CASE aDir[nChoice] == NIL
    // Must be one of our inserted elements, ie a disk drive
    cDisk := aDisplay[nChoice]
   CASE aDir[nChoice][F_ATTR]=="D" .AND. aDir[nChoice][F_NAME]==".."
    // Parent directory selected
    cDir := SUBSTR( cDir, 1, RAT( "\", LEFT( cDir, LEN( cDir ) - 1 ) ) )
   CASE aDir[nChoice][F_ATTR]=="D" .AND. aDir[nChoice][F_NAME]#"."
    // A sub-directory has been selected
    cDir := cDir + aDir[nChoice][F_NAME] + "\"
   CASE aDir[nChoice][F_ATTR] # "D"
    // Must be a file name - stuff its full path & name in the buffer
    KEYBOARD CHR( K_HOME) + CHR( K_CTRL_Y ) + cDisk + cDir +;
            TRIM( aDir[nChoice][F_NAME] )
    // Job done - get out and return
    EXIT
   OTHERWISE
    // Invalid keystroke - burp at user
    TONE( 100, 3 )
  ENDCASE
 ENDDO

RETURN NIL
